<a id="mypy-boto3-acm-pca"></a>

# mypy-boto3-acm-pca

[![PyPI - types-aiobotocore-acm-pca](https://img.shields.io/pypi/v/types-aiobotocore-acm-pca.svg?color=blue)](https://pypi.org/project/types-aiobotocore-acm-pca)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-acm-pca.svg?color=blue)](https://pypi.org/project/types-aiobotocore-acm-pca)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/types-aiobotocore-acm-pca?color=blue)](https://pypistats.org/packages/types-aiobotocore-acm-pca)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[boto3.ACMPCA 1.20.47](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/acm-pca.html#ACMPCA)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 6.4.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[types-aiobotocore-acm-pca docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_acm_pca/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/main/demo.gif)

- [mypy-boto3-acm-pca](#mypy-boto3-acm-pca)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [Versioning](#versioning)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `ACMPCA`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `ACMPCA` service.

```bash
python -m pip install types-aiobotocore[acm-pca]
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[acm-pca]` in your environment:
  `python -m pip install 'types-aiobotocore[acm-pca]'`

Both type checking and auto-complete should work for `ACMPCA` service. No
explicit type annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

- Install `types-aiobotocore[acm-pca]` in your environment:
  `python -m pip install 'types-aiobotocore[acm-pca]'`

Both type checking and auto-complete should work for `ACMPCA` service. No
explicit type annotations required, write your `aiobotocore` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed
`types-aiobotocore` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[acm-pca]` in your environment:
  `python -m pip install 'types-aiobotocore[acm-pca]'`
- Run `mypy` as usual

Type checking should work for `ACMPCA` service. No explicit type annotations
required, write your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `types-aiobotocore[acm-pca]` in your environment:
  `python -m pip install 'types-aiobotocore[acm-pca]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `ACMPCA` service. No explicit type annotations
required, write your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`ACMPCAClient` provides annotations for `session.create_client("acm-pca")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_acm_pca import ACMPCAClient

session = get_session()
with async session.create_client("acm-pca") as client:
    client: ACMPCAClient
    # now client usage is checked by mypy and IDE should provide code auto-complete
```

<a id="paginators-annotations"></a>

### Paginators annotations

`types_aiobotocore_acm_pca.paginator` module contains type annotations for all
paginators.

````python
from aiobotocore.session import get_session

from types_aiobotocore_acm_pca import ACMPCAClient
from types_aiobotocore_acm_pca.paginator import (
    ListCertificateAuthoritiesPaginator,
    ListPermissionsPaginator,
    ListTagsPaginator,
)

session = get_session()
with async session.create_client("acm-pca") as client:
    client: ACMPCAClient

    # Explicit type annotations are optional here
    # Type should be correctly discovered by mypy and IDEs
    # VSCode requires explicit type annotations
        list_certificate_authorities_paginator: ListCertificateAuthoritiesPaginator = client.get_paginator("list_certificate_authorities")
        list_permissions_paginator: ListPermissionsPaginator = client.get_paginator("list_permissions")
        list_tags_paginator: ListTagsPaginator = client.get_paginator("list_tags")
    ```


### Waiters annotations

`types_aiobotocore_acm_pca.waiter` module contains type annotations for all waiters.

```python
from aiobotocore.session import get_session

from types_aiobotocore_acm_pca.client import ACMPCAClient
from types_aiobotocore_acm_pca.waiter import (
    AuditReportCreatedWaiter,
    CertificateAuthorityCSRCreatedWaiter,
    CertificateIssuedWaiter,
)

session = get_session()
with async session.create_client("acm-pca") as client:
    client: ACMPCAClient

    # Explicit type annotations are optional here
    # Type should be correctly discovered by mypy and IDEs
    # VSCode requires explicit type annotations
        audit_report_created_waiter: AuditReportCreatedWaiter = client.get_waiter("audit_report_created")
        certificate_authority_csr_created_waiter: CertificateAuthorityCSRCreatedWaiter = client.get_waiter("certificate_authority_csr_created")
        certificate_issued_waiter: CertificateIssuedWaiter = client.get_waiter("certificate_issued")
    ```





<a id="literals"></a>

### Literals

`types_aiobotocore_acm_pca.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from types_aiobotocore_acm_pca.literals import (
    AccessMethodTypeType,
    ActionTypeType,
    AuditReportCreatedWaiterName,
    AuditReportResponseFormatType,
    AuditReportStatusType,
    CertificateAuthorityCSRCreatedWaiterName,
    CertificateAuthorityStatusType,
    CertificateAuthorityTypeType,
    CertificateIssuedWaiterName,
    ExtendedKeyUsageTypeType,
    FailureReasonType,
    KeyAlgorithmType,
    KeyStorageSecurityStandardType,
    ListCertificateAuthoritiesPaginatorName,
    ListPermissionsPaginatorName,
    ListTagsPaginatorName,
    PolicyQualifierIdType,
    ResourceOwnerType,
    RevocationReasonType,
    S3ObjectAclType,
    SigningAlgorithmType,
    ValidityPeriodTypeType,
    ServiceName,
    PaginatorName,
    WaiterName,
)

def check_value(value: AccessMethodTypeType) -> bool:
    ...
````

<a id="typed-dictionaries"></a>

### Typed dictionaries

`types_aiobotocore_acm_pca.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from types_aiobotocore_acm_pca.type_defs import (
    ASN1SubjectTypeDef,
    AccessDescriptionTypeDef,
    AccessMethodTypeDef,
    ApiPassthroughTypeDef,
    CertificateAuthorityConfigurationTypeDef,
    CertificateAuthorityTypeDef,
    CreateCertificateAuthorityAuditReportRequestRequestTypeDef,
    CreateCertificateAuthorityAuditReportResponseTypeDef,
    CreateCertificateAuthorityRequestRequestTypeDef,
    CreateCertificateAuthorityResponseTypeDef,
    CreatePermissionRequestRequestTypeDef,
    CrlConfigurationTypeDef,
    CsrExtensionsTypeDef,
    DeleteCertificateAuthorityRequestRequestTypeDef,
    DeletePermissionRequestRequestTypeDef,
    DeletePolicyRequestRequestTypeDef,
    DescribeCertificateAuthorityAuditReportRequestRequestTypeDef,
    DescribeCertificateAuthorityAuditReportResponseTypeDef,
    DescribeCertificateAuthorityRequestRequestTypeDef,
    DescribeCertificateAuthorityResponseTypeDef,
    EdiPartyNameTypeDef,
    ExtendedKeyUsageTypeDef,
    ExtensionsTypeDef,
    GeneralNameTypeDef,
    GetCertificateAuthorityCertificateRequestRequestTypeDef,
    GetCertificateAuthorityCertificateResponseTypeDef,
    GetCertificateAuthorityCsrRequestRequestTypeDef,
    GetCertificateAuthorityCsrResponseTypeDef,
    GetCertificateRequestRequestTypeDef,
    GetCertificateResponseTypeDef,
    GetPolicyRequestRequestTypeDef,
    GetPolicyResponseTypeDef,
    ImportCertificateAuthorityCertificateRequestRequestTypeDef,
    IssueCertificateRequestRequestTypeDef,
    IssueCertificateResponseTypeDef,
    KeyUsageTypeDef,
    ListCertificateAuthoritiesRequestRequestTypeDef,
    ListCertificateAuthoritiesResponseTypeDef,
    ListPermissionsRequestRequestTypeDef,
    ListPermissionsResponseTypeDef,
    ListTagsRequestRequestTypeDef,
    ListTagsResponseTypeDef,
    OcspConfigurationTypeDef,
    OtherNameTypeDef,
    PaginatorConfigTypeDef,
    PermissionTypeDef,
    PolicyInformationTypeDef,
    PolicyQualifierInfoTypeDef,
    PutPolicyRequestRequestTypeDef,
    QualifierTypeDef,
    ResponseMetadataTypeDef,
    RestoreCertificateAuthorityRequestRequestTypeDef,
    RevocationConfigurationTypeDef,
    RevokeCertificateRequestRequestTypeDef,
    TagCertificateAuthorityRequestRequestTypeDef,
    TagTypeDef,
    UntagCertificateAuthorityRequestRequestTypeDef,
    UpdateCertificateAuthorityRequestRequestTypeDef,
    ValidityTypeDef,
    WaiterConfigTypeDef,
)

def get_structure() -> ASN1SubjectTypeDef:
    return {
      ...
    }
```

<a id="versioning"></a>

## Versioning

`types-aiobotocore-acm-pca` version is the same as related `boto3` version and
follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="documentation"></a>

## Documentation

All type annotations can be found in
[types-aiobotocore-acm-pca docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_acm_pca/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
